;;; -*- Mode: Lisp; Package: BROWSEREX -*-
;;; browserex.l --- browser.dll gp̂߂̃Tv

;; Copyright (C) 2001-2002 OHKUBO Hiroshi <konata_o@hotmail.com>

;; Author: OHKUBO Hiroshi <konata_o@hotmail.com>
;; Time-stamp: <2002/10/19 12:43:25 +0900>

;;; Commentary:

;; Description:
;;
;;  satoshi oowada ̌JĂ browser.dll, browser.l 
;;  lXȗprɎgpłϑf炵̂łB
;;
;;  browser.l  browser.dll ̎gp@̃Tvt@CłA
;;  Qlɂ browser.dll ̑eLq邽߂̂̂Ȃ̂ŁA
;;  ̋Lqł browser.dll v悤ɈȂƂ܂B
;;
;;  browserex.l  browser.dll  HTML t@C̃vr[AƂ
;;  pۂɕ֗Ǝv@\ browser.l, browser.txt, browser.cpp 
;;  QlɂċLqA̃Tv Lisp t@CłB
;;
;;  ܂̌JĂ browser.dll gł̋@\p邱Ƃ
;;  ł悤ɂ܂B
;;

;; o邱:
;;
;;      E͂ꂽ URL ̓e̕\
;;      E\e̍ĕ`
;;      EJĂ邩ǂ̔
;;      E
;;      E\JniJƂĵݗLȕ\ʒui㉺EA or jw
;;      Exyzzy ̕\ʒui㉺Ej̕ύXƂ̈ʒu̎ۑ
;;      EJgobt@̃t@Ce\
;;      Et@CȂJgobt@̓e
;;        R[hEsR[hۂ܂܃e|t@Cɏo͂A
;;        HTML t@CƂĕ\
;;      EJgobt@̃t@C̃fBNg\
;;      EifBNg\̃X^C̎wj
;;      Ec[o[̑
;;      E}EXŎw肵 URLA[Jt@CpX̓e̕\
;;      EXN[
;;      EiiށA߂Az[ֈړAJĂ URI ̕\j
;;

;; Installation:
;;
;;      1. browser.dll, browser.l g悤ɂ܂B
;;
;;      2. 𓀂 browserex.l  ~/site-lisp ɃRs[܂B
;;         toolbar-browserex.bmp  ~/etc ɃRs[܂B
;;
;;      3. (KvȂ)oCgRpC܂B
;;
;;              M-x byte-compile-file
;;
;;      4. .xyzzy ܂ siteinit.l Ɉȉ̃R[hǉ܂B
;;
;;              (load-library "browserex")
;;
;;      5. KvȂ΃L[oChݒ̃R[hǉ܂B
;;
;;              F
;;              (global-set-key #\M-F9 'bx:navigate-current-buffer)
;;              (global-set-key #\M-F10 'bx:navigate-current-buffer-directory)
;;              (global-set-key #\M-F11 'bx:rotate-browser)
;;              (global-set-key #\M-F12 'bx:close-browser)
;;              (global-set-key #\RBtnUp 'bx:browserex-mouse-menu-popup)
;;              (global-set-key #\Apps 'bx:browserex-apps-popup)
;;              (global-set-key #\M-Up 'bx:browserex-scroll-up)
;;              (global-set-key #\M-Down 'bx:browserex-scroll-down)
;;              (global-set-key #\M-Left 'bx:browserex-scroll-left)
;;              (global-set-key #\M-Right 'bx:browserex-scroll-right)
;;              (global-set-key #\M-PageUp #'(lambda () (interactive) (bx:browserex-scroll-up :unit :page)))
;;              (global-set-key #\M-PageDown #'(lambda () (interactive) (bx:browserex-scroll-down :unit :page)))
;;              (global-set-key #\M-Home #'(lambda () (interactive) (bx:browserex-scroll-up :unit :all)))
;;              (global-set-key #\M-End #'(lambda () (interactive) (bx:browserex-scroll-down :unit :all)))
;;
;;      6. L̐ݒ𔽉f邽߂ɁAxyzzy ċN܂B
;;         siteinit.l ɋLqꍇ xyzzy ă_vċN܂B
;;
;;      7. KvȂ΃j[́u\vuc[o[vɒǉĂ
;;         uBrowserv`FbNAc[o[\܂B

;; Uninstallation:
;;
;;      1. M-x browserex::uninstall-browserex ƃ^CvA
;;         c[o[Abrowser.dll ̕\ʒu xyzzy 
;;         폜܂B
;;
;;      2. browserex.l ɊւLq폜܂B
;;
;;      3. siteinit.l ɋLqĂꍇ xyzzy ă_v܂B
;;

;; Changes:
;;      Sat, 19 Oct 2002 12:37:00 +0900
;;              E[Jt@CQƎ̕ϊ
;;              EƂ肠߂ browser.dll ؑցBchange-browser
;;                dll ̃t@C browser.dll  browser_gecko.dll ɁB
;;
;;      Fri, 26 Jul 2002 05:28:32 +0900
;;              E lisp t@C winapi pbP[W SetFocus `
;;                ĂA export ĂȂꍇ byte-compile
;;                łȂȂĂ_CB
;;              EWin32API ɂĒr[ winapi pbP[WŒ`Ă
;;                ̂Abrowserex pbP[WŒ`悤ɕύXB
;;
;;      Tue, 02 Jul 2002 23:06:00 +0900
;;              Ebrowserex-set-focus-editor, browser ŃtH[JXZbgB
;;              Ebrowserex-scroll-up, down, left, right ŃXN[B
;;
;;      Tue, 19 Feb 2002 20:52:25 +0900
;;              E܂ browser.dll ɑΉB
;;                ̑B
;;
;;      Thu, 17 Jan 2002 22:43:33 +0900
;;              E~/etc  browser.dll uĂ siteinit.l 
;;                browserex.l ̋LqĂ browser.dll [h
;;                łȂ̂CB
;;              E(bx:browser-dll-pathname) Ń[hĂ dll ̃pXԂB
;;              E(bx:browser-dll-define-function dll) Ŏgp dll ύXB
;;              Edll [hĂȂꍇł (browser-open-p) 퓮
;;                悤ɏCB
;;
;;      Sun, 13 Jan 2002 11:10:14 +0900
;;              E}EXŎw肵 URLA[Jt@CpX̓e̕\B
;;
;;      Tue, 08 Jan 2002 20:26:10 +0900
;;              Enavigate-current-buffer-directory ̓ύXB
;;                t@CȂꍇA"*scratch*" obt@Ȃ
;;                (user-homedir-pathname) JAȊOȂ
;;                (default-directory) J܂B
;;              EtH_JꍇAǂڍו\ւ̃X^CύX
;;                ɂĊ댯Ȃ悤Ȃ̂ŁALVS_REPORT  export Ȃ
;;                悤ɂ܂B
;;                ڍו\̃JS 0 ɂȂĂ܂悤ȂłA
;;                x񕝂𒼂΂ȂɓĂĂ悤ȋC܂B
;;              E*browser-syslistview-style-wait*
;;
;;      Mon, 07 Jan 2002 14:13:54 +0900
;;              Enavigate ̖߂lCB
;;              Eset-browser-syslistview-style ̖߂lCB
;;              Erotate-browser CB
;;              Enavigate-current-buffer-directory CB
;;              ȆB
;;
;;      Sun, 06 Jan 2002 14:57:30 +0900
;;              Ebrowser.dll ̌pX𑝂₵B
;;                xyzzy/, xyzzy/etc/, xyzzy/site-lisp/ ׂ悤
;;                Ȃ܂B
;;
;;      Sun, 06 Jan 2002 01:47:44 +0900
;;              EȂ薳 SysListView32 ̃X^CύXB
;;                bx:*browser-syslistview-style* 
;;                bx:LVS_SMALLICON, bx:LVS_LIST, bx:LVS_REPORT, bx:LVS_ICON
;;                ̂ǂꂩĂĂB
;;               u傫ACRvŴ悤Ȃ̂ bx:LVS_ICON ͈Ӗ
;;                ܂B
;;
;;      Mon, 31 Dec 2001 05:05:39 +0900
;;              Ebrowser-wrap.l P̂ browser.dll 
;;                gp@TvƂȂ悤ɂ browserex.l ɖ̕ύXB
;;

;; Todo:
;;      Ec[o[̊e{^̊֐wł悤ɂB
;;
;;

;;; Code:

(provide "browserex")

(eval-when (:compile-toplevel :load-toplevel :execute)
  (require "foreign")
  (require "wip/winapi"))

(eval-when (:compile-toplevel :load-toplevel :execute)
  (unless (find-package "browserex")
    (defpackage "browserex"
      (:nicknames "bx")
      (:use "lisp" "editor"))))

(in-package "browserex")

(export '(*browser-dll-load-path*
          *browser-size*
          *browser-width*
          *browser-height*
          *browser-start-page*
          *browser-temp-file*
          *browser-use-refresh*
          *browser-syslistview-style*
          *browser-syslistview-style-wait*
          ;;
          *browser-string-length*
          ;;
          *browserex-html-pathname-type*
          *browserex-popup-pathname-type*
          *browserex-message-valid-path*
          *browserex-full-path-regexp*))
(export '(browser-dll-define-function
          browser-dll-pathname
          browser-open-p
          navigate
          refresh-browser
          close-browser
          change-browser
          ;;
          go-back-browser
          go-forward-browser
          go-home-browser
          show-location-browser
          ;;
          rotate-browser
          navigate-current-buffer
          navigate-current-buffer-if-open
          navigate-current-buffer-directory
          get-browser-syslistview-handle
          set-browser-syslistview-style
          browserex-set-focus-editor
          browserex-set-focus-browser
          browserex-scroll-up
          browserex-scroll-down
          browserex-scroll-left
          browserex-scroll-right
          browserex-mouse-menu-popup
          browserex-apps-popup
          browser-tool-bar))

;; browser.dll ̕\ʒu
;; xpi.h
(c:*define XPIS_LEFT   0)
(c:*define XPIS_TOP    1)
(c:*define XPIS_RIGHT  2)
(c:*define XPIS_BOTTOM 3)

;; SysListView32 ̕\X^Cݒ
;; winuser.h
(c:define GWL_WNDPROC     -4)
(c:define GWL_HINSTANCE   -6)
(c:define GWL_HWNDPARENT  -8)
(c:define GWL_STYLE      -16)
(c:define GWL_EXSTYLE    -20)
(c:define GWL_USERDATA   -21)
(c:define GWL_ID         -12)

(c:define-dll-entry winapi:LONG GetWindowLong (winapi:HWND c:int)
  "user32" "GetWindowLongA")
(c:define-dll-entry winapi:LONG SetWindowLong (winapi:HWND c:int winapi:LONG)
  "user32" "SetWindowLongA")

;; commctrl.h
(c:define WC_LISTVIEWA "SysListView32")
(c:define WC_LISTVIEW  WC_LISTVIEWA)

(c:*define LVS_ICON           #x0000)
;(c:*define LVS_REPORT         #x0001)
(c:define LVS_REPORT          #x0001)
(c:*define LVS_SMALLICON      #x0002)
(c:*define LVS_LIST           #x0003)
(c:define LVS_TYPEMASK        #x0003)
(c:define LVS_SINGLESEL       #x0004)
(c:define LVS_SHOWSELALWAYS   #x0008)
(c:define LVS_SORTASCENDING   #x0010)
(c:define LVS_SORTDESCENDING  #x0020)
(c:define LVS_SHAREIMAGELISTS #x0040)
(c:define LVS_NOLABELWRAP     #x0080)
(c:define LVS_AUTOARRANGE     #x0100)
(c:define LVS_EDITLABELS      #x0200)
(c:define LVS_OWNERDATA       #x1000)
(c:define LVS_NOSCROLL        #x2000)

(c:define LVS_TYPESTYLEMASK   #xfc00)

(c:define LVS_ALIGNTOP        #x0000)
(c:define LVS_ALIGNLEFT       #x0800)
(c:define LVS_ALIGNMASK       #x0c00)

(c:define LVS_OWNERDRAWFIXED  #x0400)
(c:define LVS_NOCOLUMNHEADER  #x4000)
(c:define LVS_NOSORTHEADER    #x8000)

(c:define-dll-entry winapi:HWND
  FindWindowEx (winapi:HWND winapi:HWND winapi:LPCSTR winapi:LPCSTR)
  "user32" "FindWindowExA")
(c:define-dll-entry winapi:LRESULT
  SendMessage (winapi:HWND winapi:UINT winapi:WPARAM winapi:LPARAM)
  "user32" "SendMessageA")

(c:define WM_KEYDOWN          #x0100)
(c:define WM_KEYUP            #x0101)

(c:define WM_HSCROLL          #x0114)
(c:define WM_VSCROLL          #x0115)

(c:define VK_PRIOR          #x21)
(c:define VK_NEXT           #x22)
(c:define VK_END            #x23)
(c:define VK_HOME           #x24)
(c:define VK_LEFT           #x25)
(c:define VK_UP             #x26)
(c:define VK_RIGHT          #x27)
(c:define VK_DOWN           #x28)

(c:define SB_LINEUP           0)
(c:define SB_LINELEFT         0)
(c:define SB_LINEDOWN         1)
(c:define SB_LINERIGHT        1)
(c:define SB_PAGEUP           2)
(c:define SB_PAGELEFT         2)
(c:define SB_PAGEDOWN         3)
(c:define SB_PAGERIGHT        3)
(c:define SB_THUMBPOSITION    4)
(c:define SB_THUMBTRACK       5)
(c:define SB_TOP              6)
(c:define SB_LEFT             6)
(c:define SB_BOTTOM           7)
(c:define SB_RIGHT            7)
(c:define SB_ENDSCROLL        8)

(c:define-dll-entry winapi:HWND SetFocus (winapi:HWND) "user32")


(define-history-variable *browser-position* XPIS_LEFT
  "browser.dll ̃ftHg\ʒu")
(define-history-variable *browser-add-window* nil)
(define-history-variable *browser-save-size* nil)

(defvar *browser-size* 200
  "browser.dll ̃ftHg\A܂͍B")
(defvar *browser-width* *browser-size*
  "browser.dll ̃ftHg\B*browser-size* DB")
(defvar *browser-height* *browser-size*
  "browser.dll ̃ftHg\B*browser-size* DB")
(defvar *browser-start-page* "http://www.jsdlab.co.jp/~kamei/"
  "navigate ̃ftHg URL")
(defvar *browser-temp-file* (map-backslash-to-slash
                             (merge-pathnames "browser-temp.html"
                                              (or (si:getenv "TEMP")
                                                  (si:getenv "TMP")
                                                  (si:system-root))))
  "navigate-current-buffer ŗpe|t@C")
(defvar *browser-use-refresh* nil
  "navigate-current-buffer  refresh-browser gǂB
t ɂ refresh p(̍ۂɃtH[JX browser Ɉڂ)B")

(defvar *browser-syslistview-style* nil
  "tH_\ SysListView32 ̃X^C
LVS_ICON LVS_SMALLICON LVS_LIST nil ̂ꂩ")
(defvar *browser-syslistview-style-wait* 0.00001
  "tH_\ SysListView32 ̃X^CύXۂ̑҂")

(defvar *browserex-html-pathname-type* '("shtml" "html" "htm")
  "HTML t@C̊gq̃Xg")
(defvar *browserex-popup-pathname-type*
  '("shtml" "html" "htm" "mhtml" "mht" "xml" "txt"
    "png" "jpeg" "jpg" "jpe" "jfif" "gif" "bmp")
  "|bvAbvj[Jt@C̊gq̃Xg")
(defvar *browserex-message-valid-path* t
  "|bvAbvj[瑊΃pXŊJt@C̃tpX\")
(defvar *browserex-full-path-regexp* (compile-regexp "^[a-z]:[/\\]" t)
  "tpXƔf鐳K\")

;;; ܂  o[W
(defvar *browser-string-length* 255
  "browser.dll JĂ URI 擾ۂ̍ő啶")
;;;

(defvar *browser-dll-load-path*
  (list
   (user-homedir-pathname)
   (concat (user-homedir-pathname) "etc/")
   (concat (user-homedir-pathname) "site-lisp/")
   (si:system-root)
   (etc-path)
   (concat (si:system-root) "etc/")
   (concat (si:system-root) "site-lisp/")
   "")
  "browser.dll ̌pX")

;; browser.dll ̊֐`
(defun browser-dll-define-function (dll)
  "browser.dll 𒼐ڗp֐̒`"
  (let* ((dll-exist-p (and (file-exist-p dll)
                           (not (file-directory-p dll))))
         (fullpath (if dll-exist-p (truename dll) dll)))
    (if (fboundp 'browser-gethwnd)
        (close-browser))
    (c:define-dll-entry winapi:HWND browser-gethwnd () dll "_GetHwnd@0")
    (c:define-dll-entry c:int browser-close () dll "_close@0")
    (c:define-dll-entry c:int browser-create (winapi:HWND c:void*) dll "_create@8")
    (c:define-dll-entry c:int browser-createex (winapi:HWND c:void* c:int winapi:DWORD) dll "_createEx@16")
    (c:define-dll-entry c:int browser-navigate (c:char*) dll "_navigate@4")
    (c:define-dll-entry c:int browser-refresh () dll "_refresh@0")
;;; ܂  o[W
    (c:define-dll-entry c:int browser-go-back () dll "_goBack@0")
    (c:define-dll-entry c:int browser-go-forward () dll "_goForward@0")
    (c:define-dll-entry c:int browser-go-home () dll "_goHome@0")
    (c:define-dll-entry c:int browser-location (c:int (c:char *)) dll "_locationURL@8")
;;;

    (defun browser-dll-pathname ()
      "gpĂ dll ̃pXԂ"
      fullpath)
    (gc)
    dll-exist-p))

(let (dll (dll-filename "browser.dll"))
  (dolist (dir *browser-dll-load-path*
               (browser-dll-define-function dll-filename))
    (when (and dir
               (file-exist-p (setq dll (merge-pathnames dll-filename dir))))
      (browser-dll-define-function dll)
      (return))))

;;;
(defvar *browser-navigate-url* ""
  "ݕ\ĂpX")

(defun browser-open-p ()
  "browser.dll JĂ邩"
  (not (handler-case (zerop (browser-gethwnd)) (simple-error (c) t))))

(defun navigate (url &key position size)
  "w URL  browser.dll ŕ\"
  (interactive "sURL: " :default0 *browser-start-page*)
  (unless (browser-open-p)
    (cond
     ((find position (list XPIS_LEFT XPIS_TOP XPIS_RIGHT XPIS_BOTTOM) :test #'eql)
      (setq *browser-position* position))
     ((find *browser-position* (list XPIS_LEFT XPIS_TOP XPIS_RIGHT XPIS_BOTTOM) :test #'eql)
      (setq position *browser-position*))
     (t
      (setq position XPIS_LEFT)
      (setq *browser-position* XPIS_LEFT)))
    (unless (integerp size)
      (cond
       ((find position (list XPIS_LEFT XPIS_RIGHT) :test #'eql)
        (setq size (or *browser-width* *browser-size*)))
       ((find position (list XPIS_TOP XPIS_BOTTOM) :test #'eql)
        (setq size (or *browser-height* *browser-size*)))
       (t
        (setq size *browser-size*))))
    (unless (and (integerp size) (plusp size))
      (setq size 100))
    (browser-createex (get-window-handle) (si:plugin-arg) size position))
  (when (string-matchp "^[a-z]:" url)
    (setq url (concat "file:///" url)))
  (setq *browser-navigate-url* url)
  (browser-navigate (si:make-string-chunk url))
  (when (and (not (zerop (get-browser-syslistview-handle)))
             *browser-syslistview-style*)
    ;; wait ȂƃX^C̕ύX܂Ȃ 
    (sleep-for *browser-syslistview-style-wait*)
    (set-browser-syslistview-style))
  (start-timer 0.1 'browserex-set-focus-editor t)
  url)

(defun refresh-browser ()
  "browser.dll ̕\ URL ĕ`"
  (interactive)
  (if (browser-open-p)
      (browser-refresh)))

(defun close-browser ()
  "browser.dll "
  (interactive)
  (if (browser-open-p)
      (browser-close)))

;;; ܂  o[W
(defun go-back-browser ()
  "browser.dll Ŗ߂"
  (interactive)
  (when (browser-open-p)
    (browser-go-back)
    (start-timer 0.1 'browserex-set-focus-editor t)
;    (setq *browser-navigate-url* (get-location-from-browser))
    ))

(defun go-forward-browser ()
  "browser.dll Ői"
  (interactive)
  (when (browser-open-p)
    (browser-go-forward)
    (start-timer 0.1 'browserex-set-focus-editor t)
;    (setq *browser-navigate-url* (get-location-from-browser))
    ))

(defun go-home-browser ()
  "browser.dll  IE ̃z[Ɉړ"
  (interactive)
  (unless (browser-open-p)
    (navigate ""))
  (browser-go-home)
  (start-timer 0.1 'browserex-set-focus-editor t)
;  (setq *browser-navigate-url* (get-location-from-browser))
  )

(defun show-location-browser (&optional msgbox)
  (interactive "p")
  (if (browser-open-p)
      (if msgbox
          (msgbox (get-location-from-browser))
        (popup-string (get-location-from-browser) (point)))))

(defun get-location-from-browser ()
  (let ((len (+ *browser-string-length* 1))
        chunk)
    (setq chunk (si:make-chunk nil len))
    (browser-location len chunk)
    (si:unpack-string chunk 0)))
;;;

(defun rotate-browser ()
  "browser.dll ̕\ʒuȄɕύX"
  (interactive)
  (when (browser-open-p)
    (close-browser)
    (cond
     ((eql *browser-position* XPIS_LEFT)
      (setq *browser-position* XPIS_TOP))
     ((eql *browser-position* XPIS_TOP)
      (setq *browser-position* XPIS_RIGHT))
     ((eql *browser-position* XPIS_RIGHT)
      (setq *browser-position* XPIS_BOTTOM))
     ((eql *browser-position* XPIS_BOTTOM)
      (setq *browser-position* XPIS_LEFT))
     (t
      (setq *browser-position* XPIS_LEFT))))
  (if (string/= *browser-navigate-url* "")
      (navigate *browser-navigate-url*)
    (navigate-current-buffer)))

(defun navigate-current-buffer (&key position size temp-file)
  "Jgobt@ browser.dll ŕ\"
  (interactive)
  (let ((file (get-buffer-file-name)))
    (if file
        (if (and *browser-use-refresh*
                 (browser-open-p)
                 (string/= file *browser-temp-file*)
                 (string= file *browser-navigate-url*))
            (refresh-browser)
          (navigate file :position position :size size))
      (progn
        (unless temp-file
          (setq temp-file *browser-temp-file*))
        (with-open-file (out temp-file
                             :direction :output
                             :if-does-not-exist :create)
          (convert-encoding-from-internal
           (buffer-fileio-encoding)
           (buffer-substring (point-min) (point-max)) out))
        (navigate temp-file :position position :size size)))))

(defun navigate-current-buffer-if-open (&key temp-file)
  "browser.dll JĂJgobt@ browser.dll ŕ\"
  (interactive)
  (if (browser-open-p)
      (navigate-current-buffer :temp-file temp-file)))

(defun navigate-current-buffer-directory (&key position size)
  "Jgobt@̃fBNg browser.dll ŕ\"
  (interactive)
  (let* ((file (get-buffer-file-name))
         (dir (or (if file (directory-namestring file))
                  (if (string= (buffer-name (selected-buffer)) "*scratch*")
                      (user-homedir-pathname))
                  (default-directory))))
    (if dir
        (navigate dir :position position :size size))))

;;; browser.dll ł̃tH_\̕ύX
(defun get-browser-syslistview-handle ()
  "browser.dll ɂ SysListView32  window handle Ԃ"
  (let (parent-hwnd list-hwnd)
    (setq parent-hwnd
          (FindWindowEx
           (browser-gethwnd) 0 (si:make-string-chunk "Shell Embedding") 0))
    (setq parent-hwnd
          (FindWindowEx
           parent-hwnd 0 (si:make-string-chunk "SHELLDLL_DefView") 0))
    (setq list-hwnd
          (FindWindowEx
           parent-hwnd 0 (si:make-string-chunk "SysListView32") 0))
    (when (zerop list-hwnd)
      (setq parent-hwnd
            (FindWindowEx
             parent-hwnd 0 (si:make-string-chunk "Internet Explorer_Server") 0))
      (setq parent-hwnd
            (FindWindowEx
             parent-hwnd 0 (si:make-string-chunk "ATL Shell Embedding") 0))
      (setq list-hwnd
            (FindWindowEx
             parent-hwnd 0 (si:make-string-chunk "SysListView32") 0)))
    list-hwnd))

(defun set-browser-syslistview-style (&optional (style *browser-syslistview-style*))
  "tH_\ SysListView32 ̃X^Cݒ
X^C̒l̕ύXsS (WS_VSCROLL, WS_HSCROLL l̕␳Ȃ̂)"
  (when (or (eql style LVS_ICON)
            (eql style LVS_REPORT)
            (eql style LVS_SMALLICON)
            (eql style LVS_LIST))
    (let ((browser-syslistview-handle (get-browser-syslistview-handle))
          org mask new)
      (setq org (GetWindowLong browser-syslistview-handle GWL_STYLE))
      (setq mask (logand org (lognot LVS_TYPEMASK)))
      (setq new (logior mask style))
      (SetWindowLong browser-syslistview-handle GWL_STYLE new))
    style))

;;;
(defun get-browser-ieserver-handle ()
  (let (parent-hwnd ieserver-hwnd)
    (setq parent-hwnd
          (FindWindowEx
           (browser-gethwnd) 0 (si:make-string-chunk "Shell Embedding") 0))
    (setq parent-hwnd
          (FindWindowEx
           parent-hwnd 0 (si:make-string-chunk "Shell DocObject View") 0))
    (setq ieserver-hwnd
          (FindWindowEx
           parent-hwnd 0 (si:make-string-chunk "Internet Explorer_Server") 0))
    ieserver-hwnd))

;;; editor, browser ̃tH[JXZbg
(defun browserex-set-focus-editor ()
  (interactive)
  (SetFocus (get-window-handle)))
(defun browserex-set-focus-browser ()
  (interactive)
  (if (and (browser-open-p)
           (plusp (get-browser-ieserver-handle)))
      (SetFocus (get-browser-ieserver-handle))))

;;; XN[
(defun browserex-scroll-up (&key (unit :line) quick)
  (interactive)
  (let ((hwnd (get-browser-ieserver-handle)))
    (when (or (null hwnd) (zerop hwnd))
      (return-from browserex-scroll-up))
    (case unit
      (:all
       (SendMessage hwnd WM_VSCROLL SB_TOP 0))
      (:page
       (if quick
           (SendMessage hwnd WM_VSCROLL SB_PAGEUP 0)
         (SendMessage hwnd WM_KEYDOWN VK_PRIOR 0)))
      (:line
       (if quick
           (SendMessage hwnd WM_VSCROLL SB_LINEUP 0)
         (SendMessage hwnd WM_KEYDOWN VK_UP 0)))
      (t
       (if quick
           (SendMessage hwnd WM_VSCROLL SB_LINEUP 0)
         (SendMessage hwnd WM_KEYDOWN VK_UP 0))))))
(defun browserex-scroll-down (&key (unit :line) quick)
  (interactive)
  (let ((hwnd (get-browser-ieserver-handle)))
    (when (or (null hwnd) (zerop hwnd))
      (return-from browserex-scroll-down))
    (case unit
      (:all
       (SendMessage hwnd WM_VSCROLL SB_BOTTOM 0))
      (:page
       (if quick
           (SendMessage hwnd WM_VSCROLL SB_PAGEDOWN 0)
         (SendMessage hwnd WM_KEYDOWN VK_NEXT 0)))
      (:line
       (if quick
           (SendMessage hwnd WM_VSCROLL SB_LINEDOWN 0)
         (SendMessage hwnd WM_KEYDOWN VK_DOWN 0)))
      (t
       (if quick
           (SendMessage hwnd WM_VSCROLL SB_LINEDOWN 0)
         (SendMessage hwnd WM_KEYDOWN VK_DOWN 0))))))
(defun browserex-scroll-left (&key (unit :line) quick)
  (interactive)
  (let ((hwnd (get-browser-ieserver-handle)))
    (when (or (null hwnd) (zerop hwnd))
      (return-from browserex-scroll-left))
    (case unit
      (:all
       (SendMessage hwnd WM_HSCROLL SB_LEFT 0))
      (:line
       (if quick
           (SendMessage hwnd WM_HSCROLL SB_LINELEFT 0)
         (SendMessage hwnd WM_KEYDOWN VK_LEFT 0)))
      (t
       (if quick
           (SendMessage hwnd WM_HSCROLL SB_LINELEFT 0)
         (SendMessage hwnd WM_KEYDOWN VK_LEFT 0))))))
(defun browserex-scroll-right (&key (unit :line) quick)
  (interactive)
  (let ((hwnd (get-browser-ieserver-handle)))
    (when (or (null hwnd) (zerop hwnd))
      (return-from browserex-scroll-right))
    (case unit
      (:all
       (SendMessage hwnd WM_HSCROLL SB_RIGHT 0))
      (:line
       (if quick
           (SendMessage hwnd WM_HSCROLL SB_LINERIGHT 0)
         (SendMessage hwnd WM_KEYDOWN VK_RIGHT 0)))
      (t
       (if quick
           (SendMessage hwnd WM_HSCROLL SB_LINERIGHT 0)
         (SendMessage hwnd WM_KEYDOWN VK_RIGHT 0))))))

;;; dll ؑ
(defvar *browser-dll-alist*
  '(("IE" . "browser.dll")
    ("Gecko" . "browser_gecko.dll")))
(defvar *browser-dll-current* "IE")
(defun change-browser ()
  (interactive)
  (let (open-p)
    (cond
     ((string-equal *browser-dll-current* "IE")
      (setq *browser-dll-current* "Gecko"))
     ((string-equal *browser-dll-current* "Gecko")
      (setq *browser-dll-current* "IE")))
    (if (browser-open-p)
        (setq open-p t))
    (browser-dll-define-function
     (cdr (find *browser-dll-current* *browser-dll-alist* :test 'equal :key 'car)))
    (when open-p
      (if (string/= *browser-navigate-url* "")
          (navigate *browser-navigate-url*)
        (navigate-current-buffer)))))

;;; mouse popup
(defun browserex-mouse-menu-popup (&optional apps)
  (interactive)
  (delete-menu *app-popup-menu* 'ed::url)
  (delete-menu *app-popup-menu* 'ed::url-sep)
  (delete-menu *app-popup-menu* 'browserex-url)
  (delete-menu *app-popup-menu* 'browserex-url-sep)
  (set-window *last-mouse-window*)
  (continue-pre-selection)
  (let (menu url)
    (cond ((eql (get-selection-type) 3)
           (setq menu *app-rectangle-popup-menu*))
          ((and (eql (get-selection-type) 2)
                (save-excursion
                  (goto-char (min (selection-point)
                                  (selection-mark)))
                  (looking-at ed::*url-scheme-regexp*)))
           (setq url (buffer-substring (selection-point)
                                       (selection-mark)))
           (setq menu *app-popup-menu*))
          (t
           (setq menu *app-popup-menu*)
           (save-excursion
             (goto-last-mouse-point)
             (skip-chars-backward "-a-zA-Z0-9_/~.#@%?&=;+(),'$!*:")
             (when (looking-at ed::*url-scheme-regexp*)
               (setq url (buffer-substring (point)
                                           (progn
                                             (goto-char (match-end 0))
                                             (skip-chars-forward "-a-zA-Z0-9_/~.#@%?&=;+(),'$!*:")
                                             (point))))))))
    (when url
      (add-menu-separator menu 'ed::url-sep)
      (add-menu-item menu 'ed::url
                     (concatenate 'string (abbreviate-display-string url 40 t)
                                  " J")
                     #'(lambda ()
                         (interactive)
                         (shell-execute url t)))
      (add-menu-item menu 'browserex-url
                     (concatenate 'string (abbreviate-display-string url 40 t)
                                  "  navigate (&N)")
                     #'(lambda ()
                         (interactive)
                         (navigate url))))
    ;; local file  navigate. <BASE href=""> ͍lȂ
    (when (not url)
      (let (relative-path path valid-path
            (buffer-file-name (get-buffer-file-name)))
        (save-excursion
          (if (eql (get-selection-type) 2)
              (setq relative-path (buffer-substring (selection-point)
                                                    (selection-mark)))
            (progn
              (goto-last-mouse-point)
              (cond
               ((eql (parse-point-syntax) :string)
                (setq relative-path
                      (buffer-substring
                       (progn
                         (skip-syntax-spec-backward "^\"")
                         (point))
                       (progn
                         (skip-syntax-spec-forward "^\"")
                         (point)))))
               (t
                (setq relative-path
                      (buffer-substring
                       (progn
                         (skip-chars-backward "-a-zA-Z0-9_/~.#@%&=;+(),'$!:\\")
                         (point))
                       (progn
                         (skip-chars-forward "-a-zA-Z0-9_/~.#@%&=;+(),'$!:\\")
                         (point)))))))))

        (cond
         ;; tpX
         ((string-match *browserex-full-path-regexp* relative-path)
          (setq path relative-path))
         ;; lbg[NpX͏O
         ((string-match "\\\\" relative-path)
          (setq path ""))
         (t
          (setq path (merge-pathnames relative-path (default-directory)))))
        (cond
         ((string= path ""))
         ;; t@C݂
         ((file-exist-p path)
          (setq valid-path (map-slash-to-backslash path)))
         ;; Nw HTML t@Cw̏ꍇ
         ((and
           (string-match
            (concat "^\\(.+\\.\\(?:"
                    (substring
                     (apply 'concat
                            (mapcar #'(lambda (str)
                                        (concat "\\|" (regexp-quote str)))
                                    *browserex-html-pathname-type*)) 2)
                    "\\)\\)\\(#.*\\)")
            path)
           (file-exist-p (match-string 1)))
          (setq valid-path (concat (map-slash-to-backslash (match-string 1))
                                   (match-string 2)))
          (setq path (match-string 1)))
         ;; NwŁAJgt@CŁAt@Cꍇ
         ((and (string-match "^#" relative-path)
               buffer-file-name
               (member (pathname-type buffer-file-name) *browserex-html-pathname-type*
                       :test 'string-equal))
          (setq valid-path (concat (map-slash-to-backslash buffer-file-name)
                                   relative-path))
          (setq path buffer-file-name)))

        (when (and valid-path
                   (or
;                   (file-directory-p path)
                    (member (pathname-type path) *browserex-popup-pathname-type*
                            :test 'string-equal)))
          (if *browserex-message-valid-path*
              (message (map-slash-to-backslash valid-path)))
          (add-menu-separator menu 'browserex-url-sep)
          (add-menu-item menu 'browserex-url
                         (concat (abbreviate-display-string relative-path 40 t)
                                 "  navigate (&N)")
                         #'(lambda () (interactive) (navigate valid-path))))))
    (track-popup-menu menu (or apps :button2))))

(defun browserex-apps-popup ()
  (interactive)
  (let ((*last-mouse-window* (selected-window))
        (*last-mouse-line* (current-virtual-line-number))
        (*last-mouse-column* (current-virtual-column)))
    (browserex-mouse-menu-popup t)))

;;; tool-bar
(defun tool-bar-update-browser ()
  (or (browser-open-p) :disable))

;(defun tool-bar-update-file-name ()
;  (or (get-buffer-file-name) :disable))

(defun browser-tool-bar ()
  (create-tool-bar
   'browser-tool-bar
   (merge-pathnames "toolbar-browserex.bmp" (etc-path))
   '(("browser ŕ\" 0 navigate-current-buffer)
     ("browser ŃtH_\" 1 navigate-current-buffer-directory)
     ("browser ̕\ʒuύX" 2 rotate-browser tool-bar-update-browser)
     ("browser " 3 close-browser tool-bar-update-browser)
     )))

; tool-bar o^
(define-command-bar 'browser-tool-bar "Browser(&R)")

; tool-bar 폜
;(delete-command-bar 'browserex::browser-tool-bar)

;;; uninstall
(defun uninstall-browserex ()
  "browserex.l ̃ACXg[x"
  (interactive)
  (unregister-history-variable 'browserex::*browser-position*)
  (delete-command-bar 'browserex::browser-tool-bar))

;;; browserex.l ends here
